# vim: noexpandtab fileencoding=utf-8
# Copyright © 2008 Sabin Iacob (m0n5t3r) <iacobs-gs@m0n5t3r.info>
# 
# This file is part of gScrobbler.
#
# gScrobbler is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
import sys
import getpass
from configobj import ConfigObj
from utils import md5

__all__ = ('settings', 'queue')

conf_path = os.path.expanduser(os.path.join('~', '.config', 'gScrobbler'))
conf_file = os.path.join(conf_path, 'gscrobbler.conf')
queue_file = os.path.join(conf_path, 'queue.txt')

if not os.path.exists(conf_path):
	os.makedirs(conf_path)

need_init = not os.path.exists(conf_file)

settings = ConfigObj(conf_file, create_empty = True)
queue = ConfigObj(queue_file, create_empty = True)

if (need_init 
		or 'last.fm' not in settings 
		or 'password' not in settings['last.fm'] 
		or 'username' not in settings['last.fm'] 
		or settings['last.fm']['password'] == 'd41d8cd98f00b204e9800998ecf8427e'): # md5('')
	
	username = getpass.getuser()

	if sys.stdin.isatty():
		username = raw_input(_('Last.fm username [%s]: ') % username) or username
		password = getpass.getpass(_('Last.fm password: '))
	else:
		from dialog import get_credentials
		username, password = get_credentials(username, '')
	
	settings['last.fm'] = {
		'username': username,
		'password': md5(password)
	}
	settings.write()

