#!/usr/bin/env python

import doctest, unittest, sys, os

basedir = os.path.abspath(os.path.dirname(__file__))

suite = unittest.TestSuite()

for dirpath, dirnames, filenames in os.walk(basedir):
	for f in filenames:
		if f.endswith('.py') and f not in (os.path.basename(__file__), '__init__.py', 'config.py'):
			modprefix = dirpath.replace(basedir, '')[1:]
			modname = os.path.join(modprefix, f[:-3]).replace(os.path.sep, '.')
			if modname.startswith('build'):
				continue
			try:
				test = doctest.DocTestSuite(modname)
			except ValueError, e:
				print '%s %s' % (e[0].__name__, e[1])
				continue
			suite.addTest(test)

runner = unittest.TextTestRunner()
runner.run(suite)
